#include "main.h"
 
extern SCAN_STRUCT scanStruct;	


BOOLEAN fSignedOn = FALSE;
BOOLEAN chkKbHit(void);
int doGetch(void);

//not tested with linux
BOOLEAN EX_ConnectAllDevices ( BYTE* pbNumDevices, USHORT* pDevList, double* pdblRates )
{
	BYTE bRetValTemp = 0;
	USHORT usDevTemp = pDevList[0];
	BYTE numDevicesTemp = 0;
	double dblRateTemp = pdblRates[0];
	//BYTE initUsbLib(USHORT *usDevIDLocal, BYTE bDBG)
	bRetValTemp = initUsbLib(&usDevTemp, 0);
	if(bRetValTemp)
	{
		*pbNumDevices = 1;
		//NOTE also need to set rate after initial testing of this call, as well as loop for all devices?
		//success so leave the rest unchanged
		fSignedOn = TRUE;
		return TRUE;
	}
	else
	{
		*pbNumDevices = 0;
		pDevList[0] = 0;
		pdblRates[0] = 0.0;
		fSignedOn = FALSE;
		return FALSE;
	}
}

//use with linux
BOOLEAN EX_ConnectOneDevice(USHORT usDevID, double dblRate, BYTE bChan)
{
	//###########################
	//try and find/connect device
	//printf("\n entering EX_ConnectOneDevice \n");   
	BYTE bRetVal = 0;
	BYTE numDevicesTemp = 0;
	double dblRateTemp = dblRate;

	//printf("\n calling initUsbLib\n");
	//BYTE initUsbLib(USHORT *usDevIDLocal, BYTE bDBG);
	bRetVal = initUsbLib(&usDevID, 0);
	if(!bRetVal) return FALSE;

	//##################################
	//SUCCESS finding device - do signon
	//BYTE sendSignon(struct libusb_device_handle *hDevice, USHORT usDevID, BYTE bChan, double* dblRate, BYTE bDBG, int* iErr)
	bDBG = 0; iErr = 0;
	//BYTE sendSignon(struct libusb_device_handle *hDevice, USHORT usDevID, BYTE bChan, double* dblRate, BYTE bDBG, int* iErr);
	bRetVal = sendSignon(hDevice_global, usDevID, bChan, &dblRateTemp, bDBG, &iErr);
	if(!bRetVal) { fSignedOn = FALSE; return FALSE; }
	fSignedOn = TRUE;

	return TRUE;
}

//need to get a conversion in call to getDigitalInput to get digital input
BOOLEAN EX_SendChan(USHORT usDevID, BYTE bChan, BYTE* pbLastDigin)
{
	bDBG = 0;
	if(!fSignedOn) return FALSE;
	BYTE bLastDigin = 0;
	//BYTE sendChan(struct libusb_device_handle *hDevice, USHORT usDevID, BYTE bChan, BYTE bDBG, int* iErr);
	if(!sendChan(hDevice_global, usDevID, bChan, bDBG, &iErr))
		return FALSE;
	//BYTE getDigitalInput(struct libusb_device_handle *hDevice, USHORT usDevID, BYTE* bLastDigin, BYTE bDBG, int* iErr);
	if(!getDigitalInput(hDevice_global, usDevID, &bLastDigin, bDBG, &iErr))
		return FALSE;
	*pbLastDigin = bLastDigin;
	return TRUE;
}

BOOLEAN EX_SendDAC(USHORT usDevID, DOUBLE dblVoltage, BYTE bDAC)
{
	if(!fSignedOn) return FALSE;
	//BYTE setDAC(struct libusb_device_handle *hDevice, USHORT usDevID, BYTE bDAC, double* dlbVolts_, BYTE bDBG, int* iErr);
	if(!setDAC(hDevice_global, usDevID, bDAC, &dblVoltage, bDBG, &iErr))
		return FALSE;

	return TRUE;
}

BOOLEAN EX_GetOneConversion (USHORT usDevID, double* pdblMilliVolts)
{
	if(!fSignedOn) return FALSE;

	BYTE bLastDigin = 0;
	//BYTE getConversion(struct libusb_device_handle *hDevice, USHORT usDevID, 
	//			   double* dblVolts, BYTE* blastDigin, BYTE bDBG, int* iErr);
	if(!getConversion(hDevice_global, usDevID, pdblMilliVolts, &bLastDigin, bDBG, &iErr))
		return FALSE;
	return TRUE;
}

BOOLEAN EX_GetCalculatedRate (USHORT usDevID, double* pdblRate)
{
	BYTE bLow_, bMid_,bHigh_;
	DOUBLE dblDevRate = *pdblRate;
	//BYTE calcRateCodes(BYTE* bLow, BYTE* bMid, BYTE* bHigh, USHORT usDevID, DOUBLE* dlbDevRate);
	calcRateCodes(&bLow_, &bMid_, &bHigh_, usDevID, &dblDevRate);
	*pdblRate = dblDevRate;
	return TRUE;
}

BOOLEAN EX_SendDigout(USHORT usDevID, BYTE bDigOut)
{
	if(!fSignedOn) return FALSE;
	bDBG = 0;
	//BYTE setDigout(struct libusb_device_handle *hDevice, USHORT usDevID, BYTE bDigout, BYTE bDBG, int* iErr);
	if(!setDigout(hDevice_global, usDevID, bDigOut, bDBG, &iErr))
		return FALSE;
	return TRUE;
}

BOOLEAN EX_GetDigin(USHORT usDevID, BYTE* bDigIn)
{
	if(!fSignedOn) return FALSE;
	bDBG = 0;
	BYTE bDigin_ = *bDigIn;
	//BYTE getDigitalInput(struct libusb_device_handle *hDevice, USHORT usDevID, BYTE* bLastDigin, BYTE bDBG, int* iErr);
	if(!getDigitalInput(hDevice_global, usDevID, &bDigin_, bDBG, &iErr))
		return FALSE;
	*bDigIn = bDigin_;
	return TRUE;
}

BOOLEAN EX_SendRate(USHORT usDevID, double* dblRate)
{
	if(!fSignedOn) return FALSE;
	bDBG = 0;
	double dblRate_ = *dblRate;
	if(!sendRate(hDevice_global, usDevID, &dblRate_, bDBG, &iErr))
		return FALSE;
	return TRUE;
}

//default is single-chan
BOOLEAN EX_SetScanType ( USHORT usDevID, BYTE bScanType )
{
	//NOTE: defaults to single chan
	BOOLEAN fErrorScanType = FALSE;
	switch(bScanType)
	{
		case '1': scanStruct.uiScanToken = CMND_SINGLE_CHAN_SCAN; 
			break;
		case '2': scanStruct.uiScanToken = CMND_SINGLE_CHAN_DIGIN_SCAN; 
			break;
		case '3': scanStruct.uiScanToken = CMND_MULTI_CHAN_SCAN; 
			break;
		case '4': scanStruct.uiScanToken = CMND_MULTI_CHAN_DIGIN_SCAN; 
			break;
		case '5': scanStruct.uiScanToken = CMND_MULTI_CHAN_CAL_SCAN; 
			break;
		case '6': scanStruct.uiScanToken = CMND_MULTI_CHAN_CAL_DIGIN_SCAN; 
			break;
		default: fErrorScanType = TRUE; break;
	}
	if(fErrorScanType) return FALSE;
	return TRUE;
}

BOOLEAN EX_SetDataLogOptions ( USHORT usDevID, UINT uiDataLogMethod, UINT uiLogFileMaxSize, UINT uiMisc )
{ return TRUE; }

BOOLEAN EX_SetMultiChanScanChans ( USHORT usDevID, BYTE bChanCnt )
{
	scanStruct.uiScanChans = bChanCnt;
	return TRUE;
}

BOOLEAN EX_Run(USHORT usDevID)
{ return TRUE; }

BOOLEAN EX_CheckScanStatus ( USHORT usDevID, UINT* puiNumScansRemainingInBuff, BOOLEAN* pfStillScanning, UINT* puiStatusCode)
{ return TRUE; }

BOOLEAN EX_GetScanDataDbl ( USHORT usDevID, double* pdblDataBuff, UINT uiNumScansToReturn, BOOLEAN fGetAllRequested,
        UINT* puiNumScansReturned, UINT* puiNumScansRemainingInBuff, BOOLEAN* pfStillScanning, UINT* puiTotalBuffSize, UINT* puiStatusCode)
{ return TRUE; }

BOOLEAN EX_GetScanDataDblDigin ( USHORT usDevID, double* pdblDataBuff, BYTE* pbDiginBuff,
                                UINT uiNumScansToReturn, BOOLEAN fGetAllRequested, UINT* puiNumScansReturned,
                                UINT* puiNumScansRemainingInBuff, BOOLEAN* pfStillScanning, UINT* puiTotalBuffSize, UINT* puiErrCode)
{ return TRUE; }

BOOLEAN EX_EndScan(USHORT usDevID)
{ return TRUE; }

BOOLEAN EX_SetLengthOfRunSec ( USHORT usDevID, UINT uiSeconds )
{ return TRUE; }

//#########################################################
//#########################################################
//### SCAN ################################################
//#########################################################
//#########################################################
extern SCAN_STRUCT scanStruct;	
BOOLEAN EX_RunWithMods(USHORT usDevID, BYTE bScanType, BYTE bChanCnt, BYTE bDataLogOptions, BYTE bLengthOfRun)
{
	switch(bScanType)
	{
		case '1': scanStruct.uiScanToken = CMND_SINGLE_CHAN_SCAN; 
			break;
		case '2': scanStruct.uiScanToken = CMND_SINGLE_CHAN_DIGIN_SCAN; 
			break;
		case '3': scanStruct.uiScanToken = CMND_MULTI_CHAN_SCAN; 
			break;
		case '4': scanStruct.uiScanToken = CMND_MULTI_CHAN_DIGIN_SCAN; 
			break;
		case '5': scanStruct.uiScanToken = CMND_MULTI_CHAN_CAL_SCAN; 
			break;
		case '6': scanStruct.uiScanToken = CMND_MULTI_CHAN_CAL_DIGIN_SCAN; 
			break;
		default:  break;
	}

	scanStruct.uiScanChans = bChanCnt;
	return EX_Run(usDevID);
}

 
