//from: http://stackoverflow.com/questions/14769107/libusb-bulk-transfer

#include "main.h"

unsigned char str_tx[8];    //data to send to device  
unsigned char  *dataOut = NULL;

BYTE bUsbLibInitSuccess = 0;
BYTE bInitLibSuccess = FALSE;

int iLenIn = 8; 
int iLenOut = 32;
int iRetCode = 0;
int tRet; 

int interface_ref = 0;
int alt_interface,interface_number; 

pthread_t tid[2];

//shared with a thread so made volatile
//this is the main instance used by other source code files 
volatile SCAN_STRUCT scanStruct; 

pthread_t tid[2];
unsigned long cnt = 0;


BOOLEAN AllowPrintf(BOOLEAN fDoAllowPrintf)
{
	fAllowPrintf = fDoAllowPrintf;
}



//###########################
//## FOR REFERENCE ONLY #####
//UINT uiStackedScans = 1; 
//UINT uiBufferSizeMin = 1000;
//UINT uiBufferSizeMax;
//int* scanBuff;
//int iScanCntScanBuff = 0;
//UINT uiHeadPntr = 0, uiTailPntr = 0;
//BYTE fGotBuffWrap = 0;
//BOOLEAN fScanThreadLoopDone = FALSE;

//#define	CMND_SINGLE_CHAN_SCAN			0x89  /* Start a SingleChan scan */        
//#define	CMND_MULTI_CHAN_SCAN			0x8B  /* MultiChan scan */
//#define	CMND_MULTI_CHAN_CAL_SCAN		0x8C  /* MultiCalScan */
//#define	CMND_SINGLE_CHAN_DIGIN_SCAN		0x8D  /* SingleChanScanning /w digIn */
//#define	CMND_MULTI_CHAN_DIGIN_SCAN		0x8E  /* MultiScan w/ digIn */
//#define	CMND_MULTI_CHAN_CAL_DIGIN_SCAN	0x8F  /* MultiCalScan w/ digIn */
//#define	EndScan							0x8A  /* End a scan */          
//UINT uiScanToken;
//###########################
//###########################

//####################################################
//####################################################
//####################################################
//## scanReadCallback ################################
//####################################################
//function called whenever call to low-level driver
//  returns with/without data
void scanReadCallback(struct libusb_transfer *transfer)
{
	// called whenever a read is completed	
	int *completed = transfer->user_data;
	*completed = 1;
}


//#####################
//#####################
//#####################
//## DOSCAN ###########
//#####################
//scan thread that reads data from driver
//from: http://stackoverflow.com/questions/3508507/what-are-gcc-on-linuxs-equivalent-to-microsofts-critical-sections


volatile BYTE bCurrentCall = 0;
//following is pretty "safe" for various scan configurations. If a "buffer wrap" occurs, increase to queue more.
#define MAX_QUEUE 10  

typedef struct _SCAN_READ_CALLBACK_STRUCT
{
	int scanReadCompleted[MAX_QUEUE];
	unsigned char* dataOutScan[MAX_QUEUE];
	struct libusb_transfer* transferGrp[MAX_QUEUE];
	int scanDataStart[MAX_QUEUE];
	BOOLEAN fActiveCall[MAX_QUEUE];
} SCAN_READ_CALLBACK_STRUCT, *PSCAN_READ_CALLBACK_STRUCT;
SCAN_READ_CALLBACK_STRUCT scan_read_callback_struct;
struct libusb_transfer *transfer;  

void* doScan(void *arg)
{

//fAllowPrintf = TRUE;


//was used for testing with python 7-10-17
//if(fAllowPrintf) printf("entering scan thread \n");

	scanStruct.uiPointsInBuff = 0;

//was used for testing with python 7-10-17
//if(fAllowPrintf) printf("scanStruct.uiStackedScans: %d\n", scanStruct.uiStackedScans); 


	unsigned char bMicroBuffWrap = 0;
	unsigned char bLocalBuffWrap = 0;
	int numTransfers = scanStruct.uiStackedScans;
	int offsetMultiplier = ((numTransfers - 1) * 32);

	int* returnVal;
	int len=64,ret_alt,ret_clm,ret_rst;


	unsigned char str_tx[8];   	//data to send to device
	unsigned char str_rx[32];	//receive string
	unsigned char numChans = 1;
	sleep(1);

	BYTE isCalScan = 0;

	str_tx[0]=scanStruct.uiScanToken;		//scan token
	str_tx[1]=scanStruct.uiScanChans + isCalScan;		//chan count
	str_tx[2]=scanStruct.uiScanToken + scanStruct.uiScanChans + isCalScan; //checksum
	BOOLEAN fIsDigScan = FALSE;
	if((scanStruct.uiScanToken == CMND_SINGLE_CHAN_DIGIN_SCAN)
			|| (scanStruct.uiScanToken == CMND_MULTI_CHAN_DIGIN_SCAN)
			|| (scanStruct.uiScanToken == CMND_MULTI_CHAN_CAL_DIGIN_SCAN))
		fIsDigScan = TRUE;
	BYTE bScanPacketByteCnt = 3;
	if(fIsDigScan) bScanPacketByteCnt = 4;

	iRetCode = libusb_bulk_transfer(hDevice_global, 0x2, str_tx, 8, &iLenIn, 2000);
	unsigned int timeStart = (unsigned)time(NULL);

	if(iRetCode==-1) 
if(fAllowPrintf) printf("Error in io\n");

	if(iRetCode==0)
	{
		//printf("single-channel scan token token success.\n\n");
	}
	else
	{
if(fAllowPrintf) printf("Error in bulk transfer \n");

		*returnVal = -1;
		scanStruct.fScanThreadLoopDone = TRUE;
		scanStruct.isScanning = 0;
		scanStruct.inThread = 0;
		return returnVal;  
	}


//was used for testing with python 7-10-17
//if(fAllowPrintf) printf("continuous scan: %d\n", fContinuousScan); 

/*
if(fAllowPrintf) //6-19-17
{
	if(!fDoScanLog && !fDoDispData)
	{ printf("scan data will not be logged to file or displayed on screen!\n"); }
	if(fDoScanLog && fDoDispData)
	{ printf("scan data will logged to file and displayed on screen\n"); }
	if(fDoDispData && !fDoScanLog)
	{ printf("scan data will be displayed on screen but will not be logged to file \n"); }
	if(fDoScanLog && !fDoDispData)
	{ printf("scan data will be logged to file but will not be displayed on screen\n"); }

	if(!fDoDispData)
	{
		if(fContinuousScan)
			printf(" *you can end scan with key-press\n");
		if(fTimedScan)
			printf(" *you can end scan with key-press,\n   or will end when amount of time you've set has passed\n");
		if(!fContinuousScan && !fTimedScan)
			printf(" *you can end scan with key-press,\n   or will end when %u scans have completed\n", uiScansToDo);
	}
}
*/
	int myCnt = 0;
	char buff[32];

	int iRawCnt;
	double dblVolts;

	struct libusb_transfer *transfer;
	scanStruct.isScanning = 1;

	BYTE scanTemp[25];
	BYTE scanTempPntr = 0;
	BYTE bTempScanCntTrack = 0;

	BYTE bStackedTransferRemainingOffset = 0;

	double cpu_time_used;

	transfer = libusb_alloc_transfer(0);

	BYTE bArrayIndex = 0;

	//queue all - this queues as many requests as per MAX-QUEUE so while the results for one is being
	// processed (displayed on screen and/or logged to file) another is being processed by libusb
	//This is necessary since the firmware buffer size is limited and in order to prevent it from overflow
	// the USB driver needs to be constantly emptying it. The processing of data within this "user level" 
	// thread, even if optimized in every way, it along with other interruptions from other applications
	// or background processes can prevent usblib from keeping up with emptying of the firmware buffer.


//was used for testing with python 7-10-17
//if(fAllowPrintf) printf("numTransfers: %d\n", numTransfers); 

	for(bArrayIndex = 0; bArrayIndex < MAX_QUEUE; bArrayIndex++)
	{
		scan_read_callback_struct.scanReadCompleted[bArrayIndex] = 0;
//was used for testing with python 7-10-17
//if(fAllowPrintf) printf("marker1\n"); 

		scan_read_callback_struct.dataOutScan[bArrayIndex] = (BYTE *)malloc(32 * numTransfers);
//was used for testing with python 7-10-17
//if(fAllowPrintf) printf("marker2\n"); 
		memset(scan_read_callback_struct.dataOutScan[bArrayIndex],'\0',32);
//was used for testing with python 7-10-17
//if(fAllowPrintf) printf("marker3\n"); 
		scan_read_callback_struct.transferGrp[bArrayIndex] = libusb_alloc_transfer(0);
//was used for testing with python 7-10-17
//if(fAllowPrintf) printf("marker4\n"); 
		libusb_fill_bulk_transfer(scan_read_callback_struct.transferGrp[bArrayIndex], hDevice_global, 0x81, 
			scan_read_callback_struct.dataOutScan[bArrayIndex], 32 * numTransfers,
			scanReadCallback, &scan_read_callback_struct.scanReadCompleted[bArrayIndex], 8000);
//was used for testing with python 7-10-17
//if(fAllowPrintf) printf("marker5\n"); 
		libusb_submit_transfer(scan_read_callback_struct.transferGrp[bArrayIndex]);
//was used for testing with python 7-10-17
//if(fAllowPrintf) printf("marker6\n"); 
		scan_read_callback_struct.scanDataStart[bArrayIndex] = clock();
//was used for testing with python 7-10-17
//if(fAllowPrintf) printf("marker7\n"); 
		scan_read_callback_struct.fActiveCall[bArrayIndex] = TRUE;
	}
	bCurrentCall = 0;
	fPossibleScanPower_Err = FALSE;
	fPossibleScanUSB_Err = FALSE;
	clock_t scanDataEnd;

//was used for testing with python 7-10-17
//if(fAllowPrintf) printf("marker8\n"); 

	if(fAllowPrintf) printf("getting scan data\n"); 

	while(1==1)
	{
		int seconds = 1;
		int minutes = 1;
		int hours = 1;

		libusb_handle_events_completed(NULL, &scan_read_callback_struct.scanReadCompleted[bCurrentCall]);
		while(scan_read_callback_struct.scanReadCompleted[bCurrentCall] == 0)
		{
			libusb_handle_events_completed(NULL, &scan_read_callback_struct.scanReadCompleted[bCurrentCall]);
			//will also need to do key-press check here.
			//requeue this one at end of gettting data - increment bCurrentCall and set fActiveCall to FALSE
		}
		transfer = scan_read_callback_struct.transferGrp[bCurrentCall];

		//code to detect possible disconnect - time for transfer return greatly increased during power loss or disconnect
		scanDataEnd = clock();
		cpu_time_used = ((double) (scanDataEnd - scan_read_callback_struct.scanDataStart[bCurrentCall])) / CLOCKS_PER_SEC;

		//allow 4x actual data rate. The "10" below is because there are 10 scans in each returned 32-byte transfer
		//may want to optimize this a bit to deal with really slow scan rates.
		if( (cpu_time_used) >  (((1 / dblDataRate) * 4) * 10 * numTransfers)  )   
		{ fPossibleScanPower_Err = TRUE; }

		switch(transfer->status)
		{
			case LIBUSB_TRANSFER_COMPLETED:
				//no need to handle no error
				//printf("case: LIBUSB_TRANSFER_COMPLETED\n");
				break;
			case LIBUSB_TRANSFER_CANCELLED:
				//printf("case: 2\n");
			case LIBUSB_TRANSFER_NO_DEVICE:
				//printf("case: 3\n");
			case LIBUSB_TRANSFER_TIMED_OUT:
				//printf("case: 4\n");
			case LIBUSB_TRANSFER_ERROR:
				//printf("case: 5\n");
			case LIBUSB_TRANSFER_STALL:
				//printf("case: 6\n"); 
			case LIBUSB_TRANSFER_OVERFLOW:
				// Various type of errors here

				fUSB_ERROR = TRUE;  
				break;
		}

		if(fPossibleScanPower_Err)
		{
			fUSB_ERROR = TRUE;
			sleep(2); //allow other thread time to exit
			if(fAllowPrintf) { printf("\n\nscan data timeout\n"); printf("packet read-time taken: %lf,  packet max read-time needed: %lf \n", cpu_time_used, (((1 / dblDataRate) * 4) * 10)); }
		}
		else if(fUSB_ERROR)
		{
			fPossibleScanUSB_Err = TRUE;
			if(fAllowPrintf) { printf("\n\nscan data timeout\n"); printf("device seems to have been disconnected\n"); }
			break;
		}

		int iOffset = 0;
		//this outer FOR loop prints ALL the data. Without it, only the last 10 scans
		//   of each "stacked" packet are printed.
		unsigned char bIndex;
 
		BYTE bDoBreak = 0;
		UINT st = scanStruct.uiScanToken;  
		//static BYTE doneOnce = 0;

//was used for testing with python 7-10-17
if(fAllowPrintf) printf("DISPLAYING scan data\n"); 
		
		for(bIndex = 0; bIndex < numTransfers; bIndex++)
		{
			int iOffset = 0;
			offsetMultiplier = (bIndex * 32);

			for(iOffset = (offsetMultiplier) + 30; iOffset > (offsetMultiplier); iOffset--)  //5-10-17
			{
				if(fUSB_ERROR) { scanStruct.fScanThreadLoopDone = TRUE; bDoBreak = 1; break; }

				scanTemp[scanTempPntr] = transfer->buffer[iOffset];
				scanTempPntr++; 
				if(scanTempPntr == bScanPacketByteCnt) 
				{
					scanTempPntr = 0;
					iRawCnt = scanTemp[2] + (scanTemp[1] * 256) + (scanTemp[0] * 65536);

					scanStruct.scanBuff[scanStruct.uiHeadPntr] = iRawCnt;
					if(fIsDigScan)
						scanStruct.diginBuff[scanStruct.uiHeadPntr] = (scanTemp[3]) & 0xf;

					if((transfer->buffer[31] & 1) != 0) 
					{
						bMicroBuffWrap = TRUE;
						break;
					}


/* //was used for testing with python 7-10-17
if(fAllowPrintf) //7-10-17
{
	if(((iRawCnt - 8388608) * 0.00000059604645) >= 0) printf("\t  %lf \n", (iRawCnt - 8388608) * 0.00000059604645);
	else printf("\t %lf \n", (iRawCnt - 8388608) * 0.00000059604645);
}
*/

					(scanStruct.uiHeadPntr) = (scanStruct.uiHeadPntr) + 1; 
					if(scanStruct.uiHeadPntr == scanStruct.uiBufferSizeMax) scanStruct.uiHeadPntr = 0;

					scanStruct.uiPointsInBuff = scanStruct.uiPointsInBuff + 1;				
					if(scanStruct.uiPointsInBuff > scanStruct.uiBufferSizeMax)
					{
						scanStruct.fGotBuffWrap = 1;
						bLocalBuffWrap = 1;
						if(fAllowPrintf)  { printf("\n got LOCAL buffer wrap!\n"); printf("scans in buff: %d, max: %d", scanStruct.uiPointsInBuff, scanStruct.uiBufferSizeMax); }
						scanStruct.fScanThreadLoopDone = TRUE; bDoBreak = 1; 
						break;
					}

					myCnt++; 
					//always have this in place even for timed or num-scan 
					// type scans so the scan can be exited at any time.
					if(fContScanDone) 
					{ 
						scanStruct.fScanThreadLoopDone = TRUE; bDoBreak = 1; 
						break; 
					}

					if((!fContinuousScan) && (fTimedScan == TRUE))
					{
						if(fScanSeconds)
						{
							if( (((unsigned)time(NULL)) - timeStart) >= uiScanSeconds)
							{ 
								scanStruct.fScanThreadLoopDone = TRUE; bDoBreak = 1; 
								break; 
							}
						}
						else if(fScanMinutes)
						{
							if( ((((unsigned)time(NULL)) - timeStart) / 60 ) >= uiScanMinutes)
							{ 
								scanStruct.fScanThreadLoopDone = TRUE; bDoBreak = 1; 
								break; 
							}
						}
						else if(fScanHours)
						{
							if( ((((unsigned)time(NULL)) - timeStart) / 360 ) >= uiScanHours)
							{ 
								scanStruct.fScanThreadLoopDone = TRUE; bDoBreak = 1; 
								break; 
							}
						}
					}
				}
			}

			if(bMicroBuffWrap) break;
			if(bLocalBuffWrap) break;
			if(bDoBreak) break; 
		}

		if(bMicroBuffWrap) 
		{
			if(fAllowPrintf) { printf("\ngot MICRO-CODE buffer wrap!\n"); printf("may need to increase stacked requests"); }
			break;
		}
		if(bLocalBuffWrap)
		{
			if(fAllowPrintf) { printf("\ngot LOCAL buffer wrap!\n"); printf("may need to increase local buffer size"); }
			break;
		}

		if(bDoBreak) break;

		//re-queue the one just finished
		scan_read_callback_struct.fActiveCall[bCurrentCall] = FALSE;
		scan_read_callback_struct.scanReadCompleted[bCurrentCall] = 0;
		memset(scan_read_callback_struct.dataOutScan[bCurrentCall],'\0',32);
		scan_read_callback_struct.transferGrp[bCurrentCall] = libusb_alloc_transfer(0);
		libusb_fill_bulk_transfer(scan_read_callback_struct.transferGrp[bCurrentCall], hDevice_global, 0x81, 
			scan_read_callback_struct.dataOutScan[bCurrentCall], 32 * numTransfers,
			scanReadCallback, &scan_read_callback_struct.scanReadCompleted[bCurrentCall], 8000);
		libusb_submit_transfer(scan_read_callback_struct.transferGrp[bCurrentCall]);
		scan_read_callback_struct.scanDataStart[bCurrentCall] = clock();
		scan_read_callback_struct.fActiveCall[bCurrentCall] = TRUE;

		bCurrentCall++;
		if(bCurrentCall == MAX_QUEUE) bCurrentCall = 0;
	}
	scanStruct.fScanThreadLoopDone = TRUE;
	unsigned int timeTotal = ((unsigned)time(NULL)) - timeStart;

	while(fMainScanLoopBusy) usleep(100); 

	if(!fPossibleScanPower_Err)
		for(bArrayIndex = (MAX_QUEUE - 1); bArrayIndex > 0; bArrayIndex--)
		{
			if(scan_read_callback_struct.fActiveCall[bArrayIndex] == TRUE)
			{
				libusb_handle_events_completed(NULL, &scan_read_callback_struct.scanReadCompleted[bArrayIndex]);
				while(scan_read_callback_struct.scanReadCompleted[bArrayIndex] == 0)
					libusb_handle_events_completed(NULL, &scan_read_callback_struct.scanReadCompleted[bArrayIndex]);
			}
		}

	str_tx[0]=0x8a;		//end scan token
	str_tx[1]=0x0;		//no argument token
	str_tx[2]=0x8a;		//checksum
	iRetCode = libusb_bulk_transfer(hDevice_global,0x2,str_tx,8,&iLenIn,2000);

	unsigned char dataOut[32];	//receive string
	memset(dataOut,'\0',32);
	int iLenOut = 32;
	UINT bLoopCnt = 0;
	if(fAllowPrintf) printf("starting wait for end-scan codes echo\n");

	BOOLEAN fGotCorrectCodes = FALSE;
	while(TRUE)
	{
 		iRetCode = libusb_interrupt_transfer(hDevice_global,0x81,dataOut,32,&iLenOut,3000);
		if(iRetCode!=0) 
		{ break; }
		usleep(100);

		if((dataOut[28] == 0) && (dataOut[27] == 0x23) && (dataOut[26] == 3) && (dataOut[25] == 2) && (dataOut[24] == 1))
		{
			fGotCorrectCodes = TRUE;
			if(fAllowPrintf) printf("end-scan codes: %x, %x, %x, %x, %x\n", dataOut[28], dataOut[27], dataOut[26], dataOut[25], dataOut[24]);
			break;
		}
//following for testing to display  scan data that may not have been displayed or logged
/*
		else
		{
			BYTE bBuffIndex = 0;
			char bbBuff[512];
			char smallBuff[128];
			sprintf(bbBuff, "got more data: ");
			for(bBuffIndex = 0; bBuffIndex < 31; bBuffIndex++)
			{
				sprintf(smallBuff, "[%x] ", dataOut[bBuffIndex]);
				strcat(bbBuff, smallBuff);
			}
			sprintf(smallBuff, "\n");
			strcat(bbBuff, smallBuff);
		}
*/

		bLoopCnt++;
	}

	if(!fGotCorrectCodes) 
	if(fAllowPrintf) printf("incorrect end of scan codes (perhaps due to firmware or thread buffer wrap)");

	fEndScanTokenSent = TRUE;
	//if(fAllowPrintf) printf("set fEndScanTokenSent: %u", fEndScanTokenSent);
	
	fScanThreadWait = FALSE;

	//just allow thread to fall through - apps will do automatic cleanup
	//	pthread_exit(&tRet); //this appears to be where thread exits based on some tests
	//	*returnVal = 0;
	//	return returnVal;
}


//##############################################
//##############################################
//##############################################
//## initUsbLib ################################
//##############################################
BYTE initUsbLib(USHORT *usDevIDLocal, BYTE bDBG)
{
	//4-24-17 struct libusb_device **devs;
	struct libusb_device_handle *handle = NULL, *hDevice_expected = NULL;
	struct libusb_device *dev,*dev_expected;

	struct libusb_device_descriptor desc;
	struct libusb_endpoint_descriptor *epdesc;
	struct libusb_interface_descriptor *intdesc;

	ssize_t cnt;
	int e = 0,config2;
	int i = 0,index;

	char str1[64], str2[64];
	char found = 0;

	// Init libusb
	iRetCode = libusb_init(NULL);
	if(iRetCode < 0)
	{ 
if(fAllowPrintf) printf("\nfailed to initialise libusb\n"); 
		return 0; 
	}

	cnt = libusb_get_device_list(NULL, &devs);
	if (cnt < 0)
	{
if(fAllowPrintf) if(bDBG) printf("\nThere are no USB devices on bus\n");
		return 0;
	}
	BOOLEAN fSuccessInit = FALSE;
	
//	bDBG = TRUE;  //TEMP, but maybe just leave for quick/easy signon trouble shooting
	if(bDBG)
	{
//6-29-17		endwin();  
		system ("clear");
	}


	while ((dev = devs[i++]) != NULL)
	{
		iRetCode = libusb_get_device_descriptor(dev, &desc);
		if (iRetCode < 0)
		{
if(fAllowPrintf) if(bDBG) printf("failed to get device descriptor\n");
			libusb_free_device_list(devs,1);
			libusb_close(handle);
			break;
		}

		e = libusb_open(dev,&handle);
		if (e < 0)
		{
if(fAllowPrintf) if(bDBG) printf("error opening device\n");
			libusb_free_device_list(devs,1);
			libusb_close(handle);
			break;
		}

		if(desc.idVendor != 0x724)
		{ libusb_close(handle); }
		else
		{
			//*usDevIDLocal = desc.bcdDevice;
			if(*usDevIDLocal == desc.bcdDevice)
				fSuccessInit = TRUE;

			///*
if(fAllowPrintf)
	if(bDBG) 
	{
		printf("\nDevice Descriptors: ");    
		printf("\n\tVendor ID : %x",desc.idVendor);    
		printf("\n\tProduct ID : %x",desc.idProduct);    
		printf("\n\tSerial Number : %x",desc.iSerialNumber);    
		printf("\n\tSize of Device Descriptor : %d",desc.bLength);    
		printf("\n\tType of Descriptor : %d",desc.bDescriptorType);    
		printf("\n\tUSB Specification Release Number : %d",desc.bcdUSB);    
		printf("\n\tDevice Release Number : %d",desc.bcdDevice);    
		printf("\n\tDevice Class : %d",desc.bDeviceClass);    
		printf("\n\tDevice Sub-Class : %d",desc.bDeviceSubClass);    
		printf("\n\tDevice Protocol : %d",desc.bDeviceProtocol);    
		printf("\n\tMax. Packet Size : %d",desc.bMaxPacketSize0);    
		printf("\n\tNo. of Configuraions : %d\n",desc.bNumConfigurations); 
	}
			//*/

			hDevice_global = handle;
			iRetCode = libusb_reset_device(handle);
			if(iRetCode < 0) 
			{ 
if(fAllowPrintf) if(bDBG) printf("Error in reset : %d\n",iRetCode); 
				return 0; 
			}
			if(fSuccessInit) 
			{
if(fAllowPrintf) if(bDBG) printf("successfully connected to: %u\n", desc.bcdDevice); 

				//4-24-17
				//SHOW CURSES WINDOW AGAIN	
				
//4-26-17
/*
				while(chkKbHit()) usleep(10);
				printf("any key to clear debug display and continue\n");
				while(!chkKbHit()) usleep(10);
				doGetch();
				system ("clear");
				wrefresh(win_body); //4-5-17
				keypad(win_body, TRUE); 
				curs_set(0);
				wmove(win_body, 24, 1);
				showMainMenu();
*/
				return 1;
			}
			return 0;  //will need to change this to check more devices - currently just first found

//###############################################################
//### BELOW IS "OLD" FOR FINDING MORE DEVICES ###################
/*			
			printf("Init and reset success\n"); 
			printf("will try to signon to device \n");
			//if(usb_read(e,handle)) dev
			if(usb_read(dev,handle))
			{
				int err;
				inThread = 1;
				err = pthread_create(&(tid[i]), NULL, &doScan, NULL);
				//printf("\n marker 1\n");
				if (err != 0)
				{
					printf("\ncan't create thread :[%s]", strerror(err));
				}
				else
				{
					printf("Thread created successfully\n");
				}
				//sleep(2);
				while(inThread == 1);
				//### end scan thread stuff
			}
*/
		}

		//these are needed until app closes
		//note that the following causes a memory error if something else, such as the original
		//  running of a thread is done first. Documented error: http://www.libusb.org/ticket/136
//		libusb_close(handle);
//		libusb_free_device_list(devs,1); 
	}
//	printf("initDev returning\n");
//4-24-17	return 1;


	//############################
	//4-24-17 start new ##########
//for troubleshooting only
/* //4-28-17
	endwin();
	system ("clear");
	printf("\nno LLabs 30x device found connected.\n");
	printf("any key to continue\n");
	while(!chkKbHit()) usleep(10);
	doGetch();
	system ("clear");
	
	//SHOW CURSES WINDOW AGAIN		
	wrefresh(win_body); //4-5-17
	keypad(win_body, TRUE); 
	curs_set(0);
	wmove(win_body, 24, 1);
	showMainMenu();
	//4-24-17 start new ##########
	//############################
*/
	return 0;
}


//BOOLEAN checkDevConnect(libusb_device_handle *dev_handle)
//##*** also change in main.h
#define NO_CONNECT_ERROR 0
#define PWR_CONNECT_ERR 1
#define USB_CONNECT_ERR 2
#define UNKNOWN_CONNECT_ERR 3

BOOLEAN checkDevConnect(libusb_device_handle *dev_handle, UINT* uiErrType)
{
	BYTE bDoNothingToken = 0x6;
	str_tx[0]=bDoNothingToken;    //analog out token
	str_tx[1]=0;
	str_tx[2]=bDoNothingToken;
	iRetCode = libusb_bulk_transfer(dev_handle,0x2,str_tx,8,&iLenIn,2000);
	if(iRetCode==0)
	{
		//if(bDBG)printf("send digital output token success.\n\n");
	}
	else 
	{  
		//if(bDBG)printf("Error %d in bulk transfer (will continue in 3 seconds)\n", iRetCode); 
		//*iErr = iRetCode;
		//sleep(3);
		*uiErrType = USB_CONNECT_ERR;
		return 0; 
	}
	//dataOut[32];
	//memset(dataOut,'\0',32);  
	//3-13-17 int len=64;  
	int len=8;  
	str_tx[0]=0x81;	//getconversion token
	str_tx[1]=0x0;	//getconversion val
	str_tx[2]=0x81;	//checksum
	iRetCode = libusb_bulk_transfer(dev_handle,0x2,str_tx,8,&iLenIn,2000);
	//    printf("Error number :: %d\n",iRetCode);
	if(iRetCode==-1) 
	{
//		if(bDBG) printf("transfer return code: %d in io\n", iRetCode);
	}
	if(iRetCode==0)
	{
//		if(bDBG) printf("send get-conv token success.\n\n");
	}
	else 
	{  
		*uiErrType = UNKNOWN_CONNECT_ERR;
		return 0; 
	}

	//read getconversion
	memset(dataOut,'\0',32);
	len = 32; //3-13-17
	iRetCode = libusb_interrupt_transfer(dev_handle,0x81,dataOut,32,&iLenOut,5000);
	//    printf("Error number :: %d\n",iRetCode);
	//if(iRetCode==-1) printf("Error in io\n");

	if(iRetCode!=0)
	{
		*uiErrType = USB_CONNECT_ERR;
		return 0; 
	}
	else if(iRetCode==0)
	{
		if(dataOut[26] == 0xff)
		{
			*uiErrType = PWR_CONNECT_ERR;
			return 0;
		}
		return 1;
	}
	*uiErrType = UNKNOWN_CONNECT_ERR;
	return 0;
}




/*
BOOLEAN checkDevConnect(libusb_device_handle *dev_handle)
{
	//dataOut = (unsigned char *)malloc(32); 
	dataOut[32];
	memset(dataOut,'\0',32);  
	//3-13-17 int len=64;  
	int len=8;  
	//sleep(1);
	str_tx[0]=0x81;	//getconversion token
	str_tx[1]=0x0;	//getconversion val
	str_tx[2]=0x81;	//checksum
	iRetCode = libusb_bulk_transfer(dev_handle,0x2,str_tx,8,&iLenIn,2000);
	//    printf("Error number :: %d\n",iRetCode);
	if(iRetCode==-1) 
	{
//		if(bDBG) printf("transfer return code: %d in io\n", iRetCode);
	}
	if(iRetCode==0)
	{
//		if(bDBG) printf("send get-conv token success.\n\n");
	}
	else 
	{  
//		if(bDBG) printf("Error %d in bulk transfer (will continue in 3 seconds)\n", iRetCode); 
//		*iErr = iRetCode;
//		sleep(3);
		return 0; 
	}

	//read getconversion
	memset(dataOut,'\0',32);
	len = 32; //3-13-17
	iRetCode = libusb_interrupt_transfer(dev_handle,0x81,dataOut,32,&iLenOut,5000);
	//    printf("Error number :: %d\n",iRetCode);
	//if(iRetCode==-1) printf("Error in io\n");
	if(iRetCode==0)
	{
//4-24-17f		if(bDBG) 

//endwin();
//system ("clear");

if(dataOut[26] == 0xff) return 0;
return 1;
	}
	return 0;












	//send a dummy command to see if still connected

	BYTE bDoNothingToken = 0x6;
	//sleep(1);  //commented because can't sleep if called while scanning
	str_tx[0]=bDoNothingToken;    //analog out token
	str_tx[1]=0;
	str_tx[2]=bDoNothingToken;
	iRetCode = libusb_bulk_transfer(dev_handle,0x2,str_tx,8,&iLenIn,2000);
	if(iRetCode==0)
	{
		//if(bDBG)printf("send digital output token success.\n\n");
	}
	else 
	{  
		//if(bDBG)printf("Error %d in bulk transfer (will continue in 3 seconds)\n", iRetCode); 
		//*iErr = iRetCode;
		//sleep(3);
		return 0; 
	}
	//sleep(1);
	return 1;
}
*/


//*/

//prior to 4-24-17e
//4-24-17
/*
BOOLEAN checkDevConnect(USHORT *usDevIDLocal)
{

    libusb_context *context = NULL;
    libusb_device **list = NULL;
    int rc = 0;
    ssize_t count = 0;

    rc = libusb_init(&context);
    //assert(rc == 0);

    count = libusb_get_device_list(context, &list);
    //assert(count > 0);
	BOOLEAN fDevFound;
	size_t idx = 0;
    for (idx = 0; idx < count; ++idx) 
	{
        libusb_device *device = list[idx];
        struct libusb_device_descriptor desc = {0};
        rc = libusb_get_device_descriptor(device, &desc);
        //assert(rc == 0);
        //printf("Vendor:Device = %04x:%04x\n", desc.idVendor, desc.idProduct);
		if(desc.idVendor == 0x724)
		{
			return TRUE;
		}
    }
	return FALSE;
}
*/
DOUBLE dblActualRate;
//#########################################################################################
//#########################################################################################
//#########################################################################################
//## CALCRATECODES ########################################################################
//#########################################################################################
BYTE calcRateCodes(BYTE* bLow, BYTE* bMid, BYTE* bHigh, USHORT usDevID, DOUBLE* dblDevRate)
{
	//NOTE: following taken from our common Windows DLLs
	DOUBLE dblRateTemp = *dblDevRate;

	BYTE bModeFlagBit = 128;

	//constant for rate calculation. Is crystal frequency /512
	UINT lKVal = 9830400 / 512;
	BYTE bTypeMode = 16;
	double dbIntervalTemp = 1.0 / dblRateTemp;
	SHORT sRateCount = (SHORT)((lKVal * bTypeMode * dbIntervalTemp + 0.5) - 1);
	USHORT sRateCmndLow = sRateCount & 0xff;

	*bLow = (BYTE)sRateCmndLow;
	USHORT sRateCmdMid = bModeFlagBit | ((sRateCount & 0x1f00) / 256);
	*bMid = (BYTE)sRateCmdMid;
	*bHigh = 0;

	double dblActualInterval = (double)((((sRateCmdMid & 0x1f) * 256) + sRateCmndLow) + 1) / (lKVal * bTypeMode);
	dblActualRate = 1.0 / dblActualInterval;

    double dbl1 = (dblRateTemp - dblActualRate) * 1000000000000.0;
    double dbl2 = (dblActualRate - dblRateTemp)  * 1000000000000.0;

    if ( dbl1 > 0)
    {
		//difference between requested rate and actual rate
    }

    if (dblActualRate == dblRateTemp)
    {
		//calculated rate same as requested rate
    }


    if ( (dblActualRate != dblRateTemp) &&
            ( (dblActualRate - dblRateTemp > .000001) ||  (dblRateTemp - dblActualRate > .000001)))
    {
		//rate adjustment value
    }
    else dblActualRate = dblRateTemp;

    *dblDevRate = dblActualRate;
    return TRUE;
}


//#########################################################################################################
//#########################################################################################################
//#########################################################################################################
//## sendRate #############################################################################################
//#########################################################################################################
BYTE sendRate(struct libusb_device_handle *hDevice, USHORT usDevID, double* dblRate_, BYTE bDBG, int* iErr)
{
	BYTE bLow_, bMid_,bHigh_;
	DOUBLE dblDevRate = *dblRate_;
	//DOUBLE dlbDevRate = 100;
	calcRateCodes(&bLow_, &bMid_, &bHigh_, usDevID, &dblDevRate);
if(fAllowPrintf) if(bDBG)printf("got bLow: %d, bMid: %d, bHigh: %d\n", bLow_, bMid_, bHigh_);
//	return 1;


	//send rate
if(fAllowPrintf) 
{
	if(dblDevRate != *dblRate_)if(bDBG)printf("sending rate (requested was: %lf, adjusted: %lf\n", *dblRate_, dblDevRate);
	else if(bDBG)printf("sending rate %lf\n", dblDevRate);
}
	dblDevActualRate = dblDevRate; //6-6-17
	
	sleep(2);
	//int bLow = 255, bMid = 139, bHigh = 0;  //100
	//int bLow = 255, bMid = 139, bHigh = 0;  //200
	//int bLow = 255, bMid = 133, bHigh = 0;		//400 buffer wrap after a while
	//int bLow = 255, bMid = 129, bHigh = 0;	//600 got buffer wrap quickly
	int bLow = bLow, bMid = 129, bHigh = 0;	//1000 got buffer wrap quickly

	bLow = bLow_;
	bMid = bMid_;
	bHigh = bHigh_;

	str_tx[0]=0x84;	//rate token
	str_tx[1]=bLow; 	//
	str_tx[2]=bMid; 	//
	str_tx[3]=bHigh;	//
	str_tx[4]=0x22;	//?
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,0);
	if(iRetCode==0) 
	{ 
if(fAllowPrintf) printf("rate send success.\n"); 
	}
	else 
	{  
if(fAllowPrintf) if(bDBG)printf("Error %d sending rate (will continue in 3 seconds)\n", iRetCode);
		*iErr = iRetCode;
		sleep(3);
		return 0; 
	}

	//read rate result
	int iSuccess = 0;
	int tempCnt = 0;
	while(1==1)
	{
    	sleep(.25);
    	//iRetCode = libusb_interrupt_transfer(hDevice,0x81,dataOut,32,&iLenOut,1000);
    	iRetCode = libusb_interrupt_transfer(hDevice,0x81,dataOut,32,&iLenOut,4000);
		if((dataOut[24] == 0x1) && (dataOut[25] == 0x2) && (dataOut[26] == 0x3)
		&& ((dataOut[27] & 0xfe) == 0x22) && (dataOut[28] == bHigh) && (dataOut[29] == bMid)
		&& (dataOut[30] == bLow))
		{
if(fAllowPrintf) 
{
  			printf("got correct syscal return vals\n");
			printf("dataOut[24]: 0x%x\n", dataOut[24]);
			printf("dataOut[25]: 0x%x\n", dataOut[25]);
			printf("dataOut[26]: 0x%x\n", dataOut[26]);
			printf("dataOut[27]: 0x%x\n", dataOut[27] & 0xfe);
			printf("dataOut[28]: 0x%x\n", dataOut[28]);
			printf("dataOut[29]: 0x%x\n", dataOut[29]);
			printf("dataOut[30]: 0x%x\n", dataOut[30]);
			printf("dataOut[31]: 0x%x\n\n", dataOut[31]);
}
			iSuccess = 1;
			break;
		}
		//printf("NOT breaking\n");
		tempCnt++;

		if(tempCnt > 32) break;

	}
	if(!iSuccess)
	{
if(fAllowPrintf) printf("syscal failed - incorrect values returned (will continue in 3 seconds)\n\n");
		sleep(3);
		return 0;
	}
	*dblRate_ = dblDevRate;
	return TRUE;
}


//#############################################################################################################
//#############################################################################################################
//#############################################################################################################
//## GETACTUALRATE ############################################################################################
//#############################################################################################################
BYTE getActualRate(struct libusb_device_handle *hDevice, USHORT usDevID, double* dblRate, BYTE bDBG, int* iErr)
{
}


//#############################################################################################################
//#############################################################################################################
//#############################################################################################################
//## SENDCHAN #################################################################################################
//#############################################################################################################
BYTE sendChan(struct libusb_device_handle *hDevice, USHORT usDevID, BYTE bChan, BYTE bDBG, int* iErr)
{
	str_tx[0]=0x4;			//channel token
	str_tx[1]=bChan;		//channel
	str_tx[2]=bChan + 0x4;	//checksum
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,0);
	if(iRetCode==0) 
	{ 
		//printf("channel change success.\n\n"); 
	}
	else 
	{  
if(fAllowPrintf) printf("Error %d in bulk transfer (will continue in 3 seconds)\n", iRetCode); 
		*iErr = iRetCode;
		sleep(3);
		return 0; 
	}
	sleep(2); //temp - this needs to be a value based on rate
	return 1;
}


//#########################################################################################################
//#########################################################################################################
//#########################################################################################################
//## SENDCHAN #############################################################################################
//#########################################################################################################
BYTE setDigout(struct libusb_device_handle *hDevice, USHORT usDevID, BYTE bDigOutVal, BYTE bDBG, int* iErr)
{
	BYTE bDigoutToken = 0x2;
	//sleep(1);  //commented because can't sleep if called while scanning
	str_tx[0]=bDigoutToken;    //analog out token
	str_tx[1]=bDigOutVal;
	str_tx[2]=bDigoutToken + bDigOutVal;
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,2000);
	if(iRetCode==0)
	{
		//if(bDBG)printf("send digital output token success.\n\n");
	}
	else 
	{  
if(fAllowPrintf) if(bDBG)printf("Error %d in bulk transfer (will continue in 3 seconds)\n", iRetCode); 
		*iErr = iRetCode;
		sleep(3);
		return 0; 
	}
	//sleep(1);
	return 1;
}


//###################################################################################################################
//###################################################################################################################
//###################################################################################################################
//## SETDAC #########################################################################################################
//###################################################################################################################
BYTE setDAC(struct libusb_device_handle *hDevice, USHORT usDevID, BYTE bDAC, double* dblVolts_, BYTE bDBG, int* iErr)
{

	double dblVoltsLocal = *dblVolts_;
	double dblCntsPerVolt = 16383 / 5;
	short sCount = (short)(dblCntsPerVolt * dblVoltsLocal);
	if(sCount > 0x3fff) sCount = 0x3fff;
	short sHighByte = (short)(sCount / 64);
	short sLowByte = ((sCount - (sHighByte * 64)) * 4) + bDAC;
	sleep(1);
	str_tx[0]=0x0a;    //analog out token
	str_tx[1]=(unsigned char)(sHighByte);
	str_tx[2]=(unsigned char)((0xa + sHighByte) % 256);
	str_tx[3]=(unsigned char)(sLowByte);
	str_tx[4]=(unsigned char)(sLowByte);
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,2000);
	if(iRetCode==0)
	{
		if(bDBG)printf("send analog-out token success.\n\n");
	}
	else 
	{  
if(fAllowPrintf) if(bDBG)printf("Error %d in bulk transfer (will continue in 3 seconds)\n", iRetCode); 
		*iErr = iRetCode;
		sleep(3);
		return 0; 
	}
	sleep(1);

	return 1;
}



//###################################################################################################################
//###################################################################################################################
//###################################################################################################################
//## DOSYSCAL #######################################################################################################
//###################################################################################################################
BYTE doSyscal(struct libusb_device_handle *hDevice, USHORT usDevID, BYTE bDBG, int* iErr)
{
	BYTE bCurChan = bSingleChanScanChan;

	str_tx[0]=CMD_SYSCAL;
	str_tx[1]=0;
	str_tx[2]=0 + (unsigned char)CMD_SYSCAL;
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,2000);
	if(iRetCode==0)
	{
if(fAllowPrintf) if(bDBG)printf("syscal success.\n\n");
	}
	else 
	{  
if(fAllowPrintf) if(bDBG)printf("Error %d in bulk transfer (will continue in 3 seconds)\n", iRetCode); 
		*iErr = iRetCode;
		sleep(3);
		return 0; 
	}

	//put channel back, changed by syscal
	sendChan(hDevice_global, usDeviceID, bSingleChanScanChan, bDBG, iErr);
	sleep(1);
	return 1;
}


//###################################################################################################################
//###################################################################################################################
//###################################################################################################################
//## DOFULLSCALECAL #################################################################################################
//###################################################################################################################
BYTE doFullscaleCal(struct libusb_device_handle *hDevice, USHORT usDevID, BYTE bDBG, int* iErr)
{
	BYTE bCurChan = bSingleChanScanChan;

	str_tx[0]=CMD_FULLSCALE_CAL;
	str_tx[1]=0;
	str_tx[2]=0 + (unsigned char)CMD_FULLSCALE_CAL;
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,2000);
	if(iRetCode==0)
	{
if(fAllowPrintf) if(bDBG)printf("fullscale cal success.\n\n");
	}
	else 
	{  
if(fAllowPrintf) if(bDBG)printf("Error %d in bulk transfer (will continue in 3 seconds)\n", iRetCode); 
		*iErr = iRetCode;
		sleep(3);
		return 0; 
	}

	//put channel back, changed by syscal
	sendChan(hDevice_global, usDeviceID, bSingleChanScanChan, bDBG, iErr);
	sleep(1);
	return 1;
}


//###################################################################################################################
//###################################################################################################################
//###################################################################################################################
//## DOFULLSCALECAL #################################################################################################
//###################################################################################################################
BYTE doOffsetCal(struct libusb_device_handle *hDevice, USHORT usDevID, BYTE bDBG, int* iErr)
{
	BYTE bCurChan = bSingleChanScanChan;

	str_tx[0]=CMD_OFFSET_CAL;
	str_tx[1]=0;
	str_tx[2]=0 + (unsigned char)CMD_OFFSET_CAL;
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,2000);
	if(iRetCode==0)
	{
if(fAllowPrintf) if(bDBG)printf("offset cal success.\n\n");
	}
	else 
	{  
if(fAllowPrintf) if(bDBG)printf("Error %d in bulk transfer (will continue in 3 seconds)\n", iRetCode); 
		*iErr = iRetCode;
		sleep(3);
		return 0; 
	}

	//put channel back, changed by syscal
	sendChan(hDevice_global, usDeviceID, bSingleChanScanChan, bDBG, iErr);
	sleep(1);
	return 1;
}


//#####################################################################
//#####################################################################
//#####################################################################
//## GETCONVERSION ####################################################
//#####################################################################
BYTE getConversion(struct libusb_device_handle *hDevice, USHORT usDevID, 
		double* dblVolts_, BYTE* bLastDigin, BYTE bDBG, int* iErr)
{
	double dblVolts;
	//unsigned char  *dataIn,*dataOut;
	dataOut = (unsigned char *)malloc(32);  
	memset(dataOut,'\0',32);  
	//3-13-17 int len=64;  
	int len=8;  
	//sleep(1);
	str_tx[0]=0x81;	//getconversion token
	str_tx[1]=0x0;	//getconversion val
	str_tx[2]=0x81;	//checksum
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,2000);
	//    printf("Error number :: %d\n",iRetCode);
	if(iRetCode==-1) 
	{
if(fAllowPrintf) if(bDBG) printf("transfer return code: %d in io\n", iRetCode);
	}
	if(iRetCode==0)
	{
if(fAllowPrintf) if(bDBG) printf("send get-conv token success.\n\n");
	}
	else 
	{  
if(fAllowPrintf) if(bDBG) printf("Error %d in bulk transfer (will continue in 3 seconds)\n", iRetCode); 
		*iErr = iRetCode;
		sleep(3);
		return 0; 
	}

	//read getconversion
	sleep(1);
	memset(dataOut,'\0',32);
	len = 32; //3-13-17
	iRetCode = libusb_interrupt_transfer(hDevice,0x81,dataOut,32,&iLenOut,5000);
	//    printf("Error number :: %d\n",iRetCode);
	//if(iRetCode==-1) printf("Error in io\n");
	if(iRetCode==0)
	{
if(fAllowPrintf) if(bDBG) //6-6-17
{
	system ("clear");
	printf("success reading conversion:\n");
	printf("dataOut[0]: %d \n", dataOut[0]);
	printf("dataOut[24]: %d \n", dataOut[24]);
	printf("dataOut[25]: %d \n", dataOut[25]);
	printf("dataOut[26]: %d\n", dataOut[26]);	//if 255 then power disconnected
	printf("dataOut[27]: %d\n", dataOut[27]);
	printf("dataOut[28]: %d\n", dataOut[28]);  
	printf("dataOut[29]: %d\n", dataOut[29]);
	printf("dataOut[30]: %d\n", dataOut[30]);
	printf("dataOut[31]: %d\n\n", dataOut[31]);
}

//4-24-17f

//for troubleshooting only
/* //4-28-17
while(chkKbHit()) usleep(10);
printf("any key to clear debug display and continue\n");
while(!chkKbHit()) usleep(10);
doGetch();
system ("clear");
wrefresh(win_body);
*/


		int iRawCnt = dataOut[28] + (dataOut[29] * 256) + (dataOut[30] * 65536);
		double dblVolts = (iRawCnt - 8388608) * 0.00000059604645;
if(fAllowPrintf) if(bDBG) printf("volts: %lf\n\n", dblVolts);
		*bLastDigin = dataOut[0] & 0xf;  //5-4-17
		*dblVolts_ = dblVolts;
	}
	else 
	{  
if(fAllowPrintf) if(bDBG) printf("Error in bulk transfer (will continue in 3 seconds)\n"); 
		*iErr = iRetCode;
		sleep(3);
		return 0; 
	}
	return 1;
}


//#####################################################################
//#####################################################################
//#####################################################################
//## getDigitalInput ##################################################
//#####################################################################
//same as getting a conversion since it's returned in buffer[0] from
// firmware - just quiter - no screen output of conversion which comes
// witth it.
BYTE getDigitalInput(struct libusb_device_handle *hDevice, USHORT usDevID, 
		BYTE* bLastDigin, BYTE bDBG, int* iErr)
{
	double dblVolts;
	dataOut = (unsigned char *)malloc(32);  
	memset(dataOut,'\0',32);  
	int len=8;  
	str_tx[0]=0x81;	//getconversion token
	str_tx[1]=0x0;	//getconversion val
	str_tx[2]=0x81;	//checksum
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,2000);
	//    printf("Error number :: %d\n",iRetCode);
	if(iRetCode==-1) 
	{ 
if(fAllowPrintf) if(bDBG) printf("transfer return code: %d in io\n", iRetCode); 
	}
	if(iRetCode==0)
	{ }
	else 
	{  
		//if(bDBG) printf("Error %d in bulk transfer (will continue in 3 seconds)\n", iRetCode); 
		*iErr = iRetCode;
		sleep(3);
		return 0; 
	}

	//read getconversion
	sleep(1);
	memset(dataOut,'\0',32);
	len = 32; //3-13-17
	iRetCode = libusb_interrupt_transfer(hDevice,0x81,dataOut,32,&iLenOut,5000);
	//    printf("Error number :: %d\n",iRetCode);
	//if(iRetCode==-1) printf("Error in io\n");
	if(iRetCode==0)
	{
/*
		if(bDBG) 
		{
			endwin();
			system ("clear");
			{
				printf("success reading conversion:\n");
				printf("dataOut[0]: %d \n", dataOut[0]);
				printf("dataOut[24]: %d \n", dataOut[24]);
				printf("dataOut[25]: %d \n", dataOut[25]);
				printf("dataOut[26]: %d\n", dataOut[26]);	//if 255 then power disconnected
				printf("dataOut[27]: %d\n", dataOut[27]);
				printf("dataOut[28]: %d\n", dataOut[28]);  
				printf("dataOut[29]: %d\n", dataOut[29]);
				printf("dataOut[30]: %d\n", dataOut[30]);
				printf("dataOut[31]: %d\n\n", dataOut[31]);
			}
		}
*/

//for troubleshooting only
/* //4-28-17
while(chkKbHit()) usleep(10);
printf("any key to clear debug display and continue\n");
while(!chkKbHit()) usleep(10);
doGetch();
system ("clear");
wrefresh(win_body);
*/
		*bLastDigin = dataOut[0] & 0xf;  
	}
	else 
	{  
if(fAllowPrintf) if(bDBG) printf("Error in bulk transfer (will continue in 3 seconds)\n"); 
		*iErr = iRetCode;
		sleep(3);
		return 0; 
	}
	return 1;
}



//######################################################################################################
//######################################################################################################
//######################################################################################################
//## RESETSIMPLE #######################################################################################
//######################################################################################################
BYTE resetSimple(struct libusb_device_handle *hDevice, USHORT usDevID, BYTE bChan, BYTE bDBG, int* iErr)
{
	str_tx[0]=0x1;    //reset token
	str_tx[1]=0x0;    //no arg
	str_tx[2]=0x1;    //checksum
	int len = 8;
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,0);
	if(iRetCode==0) 
	{ 
if(fAllowPrintf) printf("simple reset success.\n\n"); 
	}
	else 
	{  
if(fAllowPrintf) printf("Error %d in bulk transfer during a reset (will continue in 3 seconds)\n", iRetCode); 
		*iErr = iRetCode;
		sleep(3);
		return 0; 
	}
	return 1;
}


//#####################################################################################################################
//#####################################################################################################################
//#####################################################################################################################
//## SENDSIGNON 6-5-17 ################################################################################################
//#####################################################################################################################
BYTE sendSignon(struct libusb_device_handle *hDevice, USHORT usDevID, BYTE bChan, double* dblRate, BYTE bDBG, int* iErr)
{
	struct  libusb_endpoint_descriptor *ep;
	struct  libusb_interface_descriptor *id;
	int len=64,ret_alt,ret_clm,ret_rst;
	struct libusb_device **list;

	dataOut = (unsigned char *)malloc(32);
	memset(dataOut,'\0',32);

	str_tx[0]=0x0;    			//token
	str_tx[0]=0x0;    			//arg
	str_tx[0]=0x0;    			//checksum
	unsigned char str_rx[32];	//receive string
	ret_rst = libusb_reset_device(hDevice);
	if(ret_rst < 0) 
	{ 
if(fAllowPrintf) if(bDBG)printf("Error in reset: %d (will continue in 3 seconds)", ret_rst); 
		*iErr = iRetCode;
		sleep(3);
		return 0; 
	}

	//SEND SIGNON
if(fAllowPrintf) if(bDBG) printf("sending signon token\n");
	len = 8; 
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,0);
	if(iRetCode==0) 
	{ 
if(fAllowPrintf) if(bDBG)printf("signon token-send success\n\n"); 
	}
	else 
	{ 
if(fAllowPrintf) if(bDBG)printf("Error %d sending signon token (will continue in 3 seconds)\n", iRetCode);
		*iErr = iRetCode;
		sleep(3);
		return 0; 
	}

	memset(dataOut,'\0',32);
	len = 0;
	int tempCnt = 0;
	len = 32; 
	while(1==1)
	{
    	sleep(.25);
    	iRetCode = libusb_interrupt_transfer(hDevice,0x81,dataOut,32,&iLenOut,3000);
		if(((dataOut[26] & 0xfe) == 0x2) && (dataOut[27] == 0x23) && (dataOut[29] == 0x8c))
		{
if(fAllowPrintf) if(bDBG)printf("got correct signon return vals\n");
			break;
		}
		tempCnt++;

		if(tempCnt > 16) break;

	}
	//printf("done loop\n");
	//printf("Error number :: %d\n",iRetCode);
    if(iRetCode==0)
    {
if(fAllowPrintf) if(bDBG)
{
	printf("signon results:\n");
	printf("dataOut[26]: 0x%x\n", dataOut[26] & 0xfe);
	printf("dataOut[27]: 0x%x\n", dataOut[27]);
	printf("dataOut[28]: 0x%x\n", dataOut[28]);
	printf("dataOut[29]: 0x%x\n", dataOut[29]);
	printf("dataOut[30]: 0x%x\n", dataOut[30]);
	printf("dataOut[31]: 0x%x\n\n", dataOut[31]);
}
    }
    else 
	{  
if(fAllowPrintf) if(bDBG)printf("Error %d reading signon return values (will continue in 3 seconds)\n", iRetCode);
		*iErr = iRetCode;
		sleep(3);
		return 0; 
	}


	//GET ACTUAL RATE BOARD CAN DO
	//BYTE calcRateCodes(BYTE* bLow, BYTE* bMid, BYTE* bHigh, USHORT usDevID, DOUBLE* dlbDevRate)
	BYTE bLow_, bMid_,bHigh_;
	DOUBLE dlbDevRate = *dblRate;
	calcRateCodes(&bLow_, &bMid_, &bHigh_, usDevID, &dlbDevRate);
if(fAllowPrintf) if(bDBG) printf("got bLow: %d, bMid: %d, bHigh: %d\n", bLow_, bMid_, bHigh_);

	//SEND RATE
	if(dlbDevRate != *dblRate)
	{
if(fAllowPrintf) if(bDBG)printf("sending rate (requested was: %lf, adjusted: %lf\n", *dblRate, dlbDevRate);
	}
	else
	{
if(fAllowPrintf) if(bDBG)printf("sending rate %lf\n", dlbDevRate);
	}
	sleep(2);

	int bLow, bMid, bHigh;		

	bLow = bLow_;
	bMid = bMid_;
	bHigh = bHigh_;

	str_tx[0]=0x84;		//rate token
	str_tx[1]=bLow; 	
	str_tx[2]=bMid; 	
	str_tx[3]=bHigh;	
	str_tx[4]=0x22;	
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,0);
	if(iRetCode==0) 
	{ 
if(fAllowPrintf) if(bDBG) printf("rate send success.\n"); 
	}
	else 
	{  
if(fAllowPrintf) if(bDBG)printf("Error %d sending rate (will continue in 3 seconds)\n", iRetCode);
		*iErr = iRetCode;
		sleep(3);
		return 0; 
	}

	//read rate result
	int iSuccess = 0;
	while(1==1)
	{
    	sleep(.25);
    	iRetCode = libusb_interrupt_transfer(hDevice,0x81,dataOut,32,&iLenOut,4000);
		if((dataOut[24] == 0x1) && (dataOut[25] == 0x2) && (dataOut[26] == 0x3)
		&& ((dataOut[27] & 0xfe) == 0x22) && (dataOut[28] == bHigh) && (dataOut[29] == bMid)
		&& (dataOut[30] == bLow))
		{
if(fAllowPrintf) if(bDBG)
{
	printf("got correct syscal return vals\n");
	printf("dataOut[24]: 0x%x\n", dataOut[24]);
	printf("dataOut[25]: 0x%x\n", dataOut[25]);
	printf("dataOut[26]: 0x%x\n", dataOut[26]);
	printf("dataOut[27]: 0x%x\n", dataOut[27] & 0xfe);
	printf("dataOut[28]: 0x%x\n", dataOut[28]);
	printf("dataOut[29]: 0x%x\n", dataOut[29]);
	printf("dataOut[30]: 0x%x\n", dataOut[30]);
	printf("dataOut[31]: 0x%x\n\n", dataOut[31]);
}
			iSuccess = 1;
			break;
		}
		tempCnt++;
		if(tempCnt > 32) break;
	}
	if(!iSuccess)
	{
if(fAllowPrintf) if(bDBG) printf("syscal failed - incorrect values returned (will continue in 3 seconds)\n\n");
		sleep(3);
		return 0;
	}


	//send channel
	bChan = 0; //4-5-17 new init default value is chan 0
if(fAllowPrintf) if(bDBG)printf("sending channel: %d\n", bChan);
	str_tx[0]=0x4;		//setChan token
	str_tx[1]=bChan;	//channel val
	str_tx[2]=0x4;		//checksum
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,0);
	//    printf("Error number :: %d\n",iRetCode);
	if(iRetCode==0) 
	{ 
if(fAllowPrintf) if(bDBG) printf("channel change success.\n\n"); 
	}
	else 
	{  
if(fAllowPrintf) if(bDBG)printf("Error %d sending channel (will continue in 3 seconds)\n", iRetCode);
		*iErr = iRetCode;
		sleep(3);
		return 0; 
	}

	sleep(3); //6-6-17 note: needs to be product of RATE.




//FOLLOWING JUST FOR TESTING - typically, just leave DAC alone
/* 
// set DAC
	double dblVolts = 2.5;
	unsigned char bDac = 0;
	double dblCntsPerVolt = 16383 / 5;
	short sCount = (short)(dblCntsPerVolt * dblVolts);
	short sHighByte = (short)(sCount / 64);
	short sLowByte = ((sCount - (sHighByte * 64)) * 4) + bDac;
	sleep(1);
	str_tx[0]=0x0a;    //analog out token
	str_tx[1]=(unsigned char)(sHighByte);
	str_tx[2]=(unsigned char)((0xa + sHighByte) % 256);
	str_tx[3]=(unsigned char)(sLowByte);
	str_tx[4]=(unsigned char)(sLowByte);
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,2000);
	//    printf("Error number :: %d\n",iRetCode);
	if(iRetCode==-1) printf("Error in io\n");
	if(iRetCode==0)
	{
		printf("send analog-out token success.\n\n");
	}
	else {  printf("Error in bulk transfer\n"); return 0; }
	sleep(1);
// end set DAC
*/
/*
	//TEST SIGNON BY GETTING A CONVERSION
	sleep(1);
	if(bDBG) printf("testing by getting a conversion on channel %d \n\n", bChan);
	str_tx[0]=0x81;		//getconversion token
	str_tx[1]=0x0;		//nothing here
	str_tx[2]=0x81;		//checksum
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,2000);
	if(iRetCode==-1) if(bDBG) printf("Error in io\n");
	if(iRetCode==0)
	{ if(bDBG)printf("send get-conv token success.\n\n"); }
	else 
	{  
		if(bDBG)printf("Error %d sending get-conv token (will continue in 3 seconds)\n", iRetCode);
		*iErr = iRetCode;
		sleep(3);
		return 0; 
	}

	//read getconversion
	sleep(1);
	memset(dataOut,'\0',32);
	iRetCode = libusb_interrupt_transfer(hDevice,0x81,dataOut,32,&len,5000);
	//    printf("Error number :: %d\n",iRetCode);
	if((iRetCode==0) && bDBG)
	{
		printf("success reading conversion:\n");
		printf("dataOut[0]: %d \n", dataOut[0]);
		printf("dataOut[26]: %d\n", dataOut[26]);
		printf("dataOut[27]: %d\n", dataOut[27]);
		printf("dataOut[28]: %d\n", dataOut[28]);
		printf("dataOut[29]: %d\n", dataOut[29]);
		printf("dataOut[30]: %d\n", dataOut[30]);
		printf("dataOut[31]: %d\n\n", dataOut[31]);

		int iRawCnt = dataOut[28] + (dataOut[29] * 256) + (dataOut[30] * 65536);
		dblVolts = (iRawCnt - 8388608) * 0.00000059604645; //dblVolts is shared
		printf("volts (from trial conversion channel 0): %lf\n\n", dblVolts);
		bLastDigin = dataOut[0] & 0xf;  //5-4-17
		fGotDigin = TRUE;

		sleep(2);
	}
	else 
	{  
		if(bDBG)printf("Error %d reading conversion (will continue in 3 seconds)\n", iRetCode);
		*iErr = iRetCode;
		sleep(3);
		return 0; 
	}
*/
	return 1;
}



//#####################################################################################################################
//#####################################################################################################################
//#####################################################################################################################
//## SIGNONFULL #######################################################################################################
//#####################################################################################################################
BYTE signonFull(struct libusb_device_handle *hDevice, USHORT usDevID, BYTE bChan, double* dblRate, BYTE bDBG, int* iErr)
{
	struct  libusb_endpoint_descriptor *ep;
	struct  libusb_interface_descriptor *id;
	int len=64,ret_alt,ret_clm,ret_rst;
	struct libusb_device **list;

	dataOut = (unsigned char *)malloc(32);
	memset(dataOut,'\0',32);

	str_tx[0]=0x0;    			//token
	str_tx[0]=0x0;    			//arg
	str_tx[0]=0x0;    			//checksum
	unsigned char str_rx[32];	//receive string
	ret_rst = libusb_reset_device(hDevice);
	if(ret_rst < 0) 
	{ 
if(fAllowPrintf) if(bDBG)printf("Error in reset: %d (will continue in 3 seconds)", ret_rst); 
		*iErr = iRetCode;
		sleep(3);
		return 0; 
	}

	//SEND SIGNON
if(fAllowPrintf) if(bDBG) printf("sending signon token\n");
	len = 8; 
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,0);
	if(iRetCode==0) 
	{ 
if(fAllowPrintf) if(bDBG)printf("signon token-send success\n\n"); 
	}
	else 
	{ 
if(fAllowPrintf) if(bDBG)printf("Error %d sending signon token (will continue in 3 seconds)\n", iRetCode);
		*iErr = iRetCode;
		sleep(3);
		return 0; 
	}

	memset(dataOut,'\0',32);
	len = 0;
	int tempCnt = 0;
	len = 32; 
	while(1==1)
	{
    	sleep(.25);
    	iRetCode = libusb_interrupt_transfer(hDevice,0x81,dataOut,32,&iLenOut,3000);
		if(((dataOut[26] & 0xfe) == 0x2) && (dataOut[27] == 0x23) && (dataOut[29] == 0x8c))
		{
if(fAllowPrintf) if(bDBG)printf("got correct signon return vals\n");
			break;
		}
		tempCnt++;

		if(tempCnt > 16) break;

	}
	//printf("done loop\n");
	//printf("Error number :: %d\n",iRetCode);
    if(iRetCode==0)
    {
if(fAllowPrintf) if(bDBG)
{
	printf("signon results:\n");
	printf("dataOut[26]: 0x%x\n", dataOut[26] & 0xfe);
	printf("dataOut[27]: 0x%x\n", dataOut[27]);
	printf("dataOut[28]: 0x%x\n", dataOut[28]);
	printf("dataOut[29]: 0x%x\n", dataOut[29]);
	printf("dataOut[30]: 0x%x\n", dataOut[30]);
	printf("dataOut[31]: 0x%x\n\n", dataOut[31]);
}
    }
    else 
	{  
if(fAllowPrintf) if(bDBG)printf("Error %d reading signon return values (will continue in 3 seconds)\n", iRetCode);
		*iErr = iRetCode;
		sleep(3);
		return 0; 
	}


	//GET ACTUAL RATE BOARD CAN DO
	//BYTE calcRateCodes(BYTE* bLow, BYTE* bMid, BYTE* bHigh, USHORT usDevID, DOUBLE* dlbDevRate)
	BYTE bLow_, bMid_,bHigh_;
	DOUBLE dlbDevRate = *dblRate;
	calcRateCodes(&bLow_, &bMid_, &bHigh_, usDevID, &dlbDevRate);
if(fAllowPrintf) if(bDBG) printf("got bLow: %d, bMid: %d, bHigh: %d\n", bLow_, bMid_, bHigh_);

	//SEND RATE
	if(dlbDevRate != *dblRate)
	{
if(fAllowPrintf) if(bDBG)printf("sending rate (requested was: %lf, adjusted: %lf\n", *dblRate, dlbDevRate);
	}
	else 
	{
if(fAllowPrintf) if(bDBG)printf("sending rate %lf\n", dlbDevRate);
	}
	sleep(2);

	int bLow, bMid, bHigh;		

	bLow = bLow_;
	bMid = bMid_;
	bHigh = bHigh_;

	str_tx[0]=0x84;		//rate token
	str_tx[1]=bLow; 	
	str_tx[2]=bMid; 	
	str_tx[3]=bHigh;	
	str_tx[4]=0x22;	
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,0);
	if(iRetCode==0) 
	{ 
if(fAllowPrintf) if(bDBG) printf("rate send success.\n"); 
	}
	else 
	{  
if(fAllowPrintf) if(bDBG)printf("Error %d sending rate (will continue in 3 seconds)\n", iRetCode);
		*iErr = iRetCode;
		sleep(3);
		return 0; 
	}

	//read rate result
	int iSuccess = 0;
	while(1==1)
	{
    	sleep(.25);
    	iRetCode = libusb_interrupt_transfer(hDevice,0x81,dataOut,32,&iLenOut,4000);
		if((dataOut[24] == 0x1) && (dataOut[25] == 0x2) && (dataOut[26] == 0x3)
		&& ((dataOut[27] & 0xfe) == 0x22) && (dataOut[28] == bHigh) && (dataOut[29] == bMid)
		&& (dataOut[30] == bLow))
			if(bDBG)
			{
if(fAllowPrintf) //6-19-17
{
	printf("got correct syscal return vals\n");
	printf("dataOut[24]: 0x%x\n", dataOut[24]);
	printf("dataOut[25]: 0x%x\n", dataOut[25]);
	printf("dataOut[26]: 0x%x\n", dataOut[26]);
	printf("dataOut[27]: 0x%x\n", dataOut[27] & 0xfe);
	printf("dataOut[28]: 0x%x\n", dataOut[28]);
	printf("dataOut[29]: 0x%x\n", dataOut[29]);
	printf("dataOut[30]: 0x%x\n", dataOut[30]);
	printf("dataOut[31]: 0x%x\n\n", dataOut[31]);
}
				iSuccess = 1;
				break;
			}
		tempCnt++;
		if(tempCnt > 32) break;
	}
	if(!iSuccess)
	{
if(fAllowPrintf) if(bDBG) printf("syscal failed - incorrect values returned (will continue in 3 seconds)\n\n");
		sleep(3);
		return 0;
	}


	//send channel
	bChan = 0; //4-5-17 new init default value is chan 0
	if(bDBG)printf("sending channel: %d\n", bChan);
	str_tx[0]=0x4;		//setChan token
	str_tx[1]=bChan;	//channel val
	str_tx[2]=0x4;		//checksum
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,0);
	//    printf("Error number :: %d\n",iRetCode);
	if(iRetCode==0) 
	{ 
if(fAllowPrintf) if(bDBG) printf("channel change success.\n\n"); 
	}
	else 
	{  
if(fAllowPrintf) if(bDBG)printf("Error %d sending channel (will continue in 3 seconds)\n", iRetCode);
		*iErr = iRetCode;
		sleep(3);
		return 0; 
	}

//FOLLOWING JUST FOR TESTING - typically, just leave DAC alone
/* 
// set DAC
	double dblVolts = 2.5;
	unsigned char bDac = 0;
	double dblCntsPerVolt = 16383 / 5;
	short sCount = (short)(dblCntsPerVolt * dblVolts);
	short sHighByte = (short)(sCount / 64);
	short sLowByte = ((sCount - (sHighByte * 64)) * 4) + bDac;
	sleep(1);
	str_tx[0]=0x0a;    //analog out token
	str_tx[1]=(unsigned char)(sHighByte);
	str_tx[2]=(unsigned char)((0xa + sHighByte) % 256);
	str_tx[3]=(unsigned char)(sLowByte);
	str_tx[4]=(unsigned char)(sLowByte);
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,2000);
	//    printf("Error number :: %d\n",iRetCode);
	if(iRetCode==-1) printf("Error in io\n");
	if(iRetCode==0)
	{
		printf("send analog-out token success.\n\n");
	}
	else {  printf("Error in bulk transfer\n"); return 0; }
	sleep(1);
// end set DAC
*/

	//TEST SIGNON BY GETTING A CONVERSION
	sleep(1);
	if(bDBG) printf("testing by getting a conversion on channel %d \n\n", bChan);
	str_tx[0]=0x81;		//getconversion token
	str_tx[1]=0x0;		//nothing here
	str_tx[2]=0x81;		//checksum
	iRetCode = libusb_bulk_transfer(hDevice,0x2,str_tx,8,&iLenIn,2000);
	if(iRetCode==-1) if(bDBG) printf("Error in io\n");
	if(iRetCode==0)
	{ 
if(fAllowPrintf) if(bDBG)printf("send get-conv token success.\n\n"); 
	}
	else 
	{  
if(fAllowPrintf) if(bDBG)printf("Error %d sending get-conv token (will continue in 3 seconds)\n", iRetCode);
		*iErr = iRetCode;
		sleep(3);
		return 0; 
	}

	//read getconversion
	sleep(1);
	memset(dataOut,'\0',32);
	iRetCode = libusb_interrupt_transfer(hDevice,0x81,dataOut,32,&len,5000);
	//    printf("Error number :: %d\n",iRetCode);
	if((iRetCode==0) && bDBG)
	{
if(fAllowPrintf) //6-19-17
{
	printf("success reading conversion:\n");
	printf("dataOut[0]: %d \n", dataOut[0]);
	printf("dataOut[26]: %d\n", dataOut[26]);
	printf("dataOut[27]: %d\n", dataOut[27]);
	printf("dataOut[28]: %d\n", dataOut[28]);
	printf("dataOut[29]: %d\n", dataOut[29]);
	printf("dataOut[30]: %d\n", dataOut[30]);
	printf("dataOut[31]: %d\n\n", dataOut[31]);
}

		int iRawCnt = dataOut[28] + (dataOut[29] * 256) + (dataOut[30] * 65536);
		dblVolts = (iRawCnt - 8388608) * 0.00000059604645; //dblVolts is shared
if(fAllowPrintf) printf("volts (from trial conversion channel 0): %lf\n\n", dblVolts);
		bLastDigin = dataOut[0] & 0xf;  //5-4-17
		fGotDigin = TRUE;

		sleep(2);
	}
	else 
	{  
if(fAllowPrintf) if(bDBG)printf("Error %d reading conversion (will continue in 3 seconds)\n", iRetCode);
		*iErr = iRetCode;
		sleep(3);
		return 0; 
	}

	return 1;
}


//#################
//#################
//#################
//## CLOSEDEV #####
//#################
BYTE closeDev(void)
{
	libusb_close(hDevice_global);
	return 1;
}

